import paho.mqtt.client as mqtt
import socket
import json
import time

MQTT_HOST = '194.30.33.69'
MQTT_PORT = 1883
LOGSTASH_HOST = '127.0.0.1'
LOGSTASH_PORT_RPI = 9400
LOGSTASH_PORT_AIRQ = 9401
LOGSTASH_PORT_GPS = 9402
LOGSTASH_PORT_EMETER = 9403
CM_PER_SEC_AIR = 34300
mqttTelemetryTopic = ["RPi.Data","AirQ/+/+","GPS/+","Emeter/+/+"]

def on_connect(client, userdata, flags, rc):
    print("Connected with result code " + str(rc))
    client.subscribe([(mqttTelemetryTopic[0],0),(mqttTelemetryTopic[1],0),(mqttTelemetryTopic[2],0),(mqttTelemetryTopic[3],0)])

def on_message(client, userdata, msg):
    global s1, s2, s3, s4
    topic=msg.topic.split("/")
    if topic[0]==mqttTelemetryTopic[0]:
        s1.send(msg.payload)
        s1.send('\n')
    elif topic[0]=="AirQ":
        s2.send(msg.payload)
        s2.send('\n')
    elif topic[0]=="GPS":
        s3.send(msg.payload)
        s3.send('\n')
    elif topic[0]=="Emeter":
        s4.send(msg.payload)
        s4.send('\n')
    else:
        s.send(msg.payload)
        s.send('\n')
    #print(msg.topic + " " + str(msg.payload))

client = mqtt.Client()
client.on_connect = on_connect
client.on_message = on_message
client.connect(MQTT_HOST, MQTT_PORT, 60)
s1 = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
s1.connect((LOGSTASH_HOST, LOGSTASH_PORT_RPI))
s2 = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
s2.connect((LOGSTASH_HOST, LOGSTASH_PORT_AIRQ))
s3 = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
s3.connect((LOGSTASH_HOST, LOGSTASH_PORT_GPS))
s4 = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
s4.connect((LOGSTASH_HOST, LOGSTASH_PORT_EMETER))
client.loop_forever()
