# -*- coding: utf-8 -*-
import paho.mqtt.client as mqtt
import ModBus_client
import json
import ssl
import datetime
import time
import pprint

class Mqtt_Modbus:
    def __init__(self):
        self.mqttBrokerHost = "194.30.33.69"
        self.mqttBrokerPort = 1883
        self.mqttBrokerUser = "<user name>"
        self.mqttBrokerPassword = "<password>"
        self.mqttTopicBase = "Emeter"
        self.timeRequest = 60
        self.clientBroker = mqtt.Client() #Cliente para publicar los datos a elasticSearch
        self.dev_id="Medidor_General-"
        self.location="Edificio103"
        self.log_path= "modbusTCPclient.log"

    def on_connect(self, client, userdata, flags, rc):
        timestamp = time.strftime('%b  %d %H:%M:%s')
        if rc == 0:
            print("Connected to MQTT broker (RC: %s)" % rc)
            filelog = open(self.log_path,'a')
            filelog.write(timestamp+':Connected to MQTT broker rc:'+str(rc)+'\n')
            filelog.close()
        else:
            print("Connection to MQTT broker failed (RC: %s)" % rc)
            filelog = open(self.log_path,'a')
            filelog.write(timestamp+':Connected to MQTT broker FAILED rc:'+str(rc)+'\n')
            filelog.close()

    def on_disconnect(self, client, userdata, rc):
        timestamp = time.strftime('%b  %d %H:%M:%s')
        if rc != 0:
            print("Unexpected Disconnect from MQTT broker")
            filelog = open(self.log_path,'a')
            filelog.write(timestamp+':Connected to MQTT broker FAILED rc:'+str(rc)+'\n')
            filelog.close()
        print("Disconnected from MQTT broker")
        filelog = open(self.log_path,'a')
        filelog.write(timestamp+':DisConnected from MQTT broker rc:'+str(rc)+'\n')
        filelog.close()
    def convList2Json(self,lista):#convierte la lista a un objeto JSON
        json_data = json.loads('{}')
        for elemento in lista:
            json_data[elemento[0]] = elemento[1]
        return json_data


    def launch_client(self, host, netId):
        self.clientBroker.on_connect = self.on_connect
        self.clientBroker.on_disconnect = self.on_disconnect
        self.clientBroker.connect(self.mqttBrokerHost, self.mqttBrokerPort, 60)#Puerto 1883(MQTT) sin TLS, con TLS puerto 8883
        # Comienzo del bucle en la conexion MQTT con el broker
        self.clientBroker.loop_start()
        circutor = ModBus_client.ModbusClient(netId,host, self.log_path)# objeto ModBusClient a traves de TCP, ModbusClient(Id en red, dirección IP gateway a red ModBus)

        while True:
            data = circutor.getInstantaneusRegister()
            #data = circutor.getSingleRegister()
            print("Nº Campos=%d"% len(data))
            json_data = self.convList2Json(data)
            json_data['dev_id'] = self.dev_id+str(netId)
            json_data['metadata'] = {}
            json_data['metadata']['time'] = datetime.datetime.utcnow().isoformat()
            payload = json.dumps(json_data)
            circutor.tags=[]
            circutor.messageError=[]
            pprint.pprint(json_data)
            topic = self.mqttTopicBase + '/'+ self.location + '/' +self.dev_id
            self.clientBroker.publish(topic, payload, 1)
            timestamp = time.strftime('%b  %d %H:%M:%s')
            filelog = open(self.log_path,'a')
            filelog.write(timestamp+':Message Delivered:\n')
            filelog.close()
            time.sleep(self.timeRequest)#tiempo de espera entre cada lectura de los elementos ModBus

if __name__ == "__main__":
    import sys
    instance = Mqtt_Modbus()
    instance.launch_client(str(sys.argv[1]), int(sys.argv[2]))
