//*********************************************************************
//*************  Copyright (C) 2008        OWASYS  ********************
//*********************************************************************
//**
//** The copyright to the computer programs here in is the property of
//** OWASYS The programs may be used and/or copied only with the
//** written permission from OWASYS or in accordance with the terms and
//** conditions stipulated in the agreement/contract under which the
//** programs have been supplied.
//**
//*********************************************************************
//******************** Module information *****************************
//**
//** Project:
//** Description:
//**
//** Filename:      LoadLibs.h
//** Owner:         Owasys
//** Creation date: 03/11/2010
//**
//*********************************************************************
//******************** Revision history *******************************
//** Revision date       Comments                           Responsible
//** -------- ---------- ---------------------------------- -----------
//** P1A      03/11/2010 Created                            owzigp
//*********************************************************************

#ifndef __LOAD_LIBS_H
   #define __LOAD_LIBS_H

//-----------------------------------------------------------------//
//System Includes
//-----------------------------------------------------------------//
#include <string.h>
#include <stdarg.h>
//#include <time.h>

//-----------------------------------------------------------------//
//User Includes
//-----------------------------------------------------------------//
#include "owa3x/owcomdefs.h"
#include "owa3x/owa31/IOs_ModuleDefs.h"
#include "owa3x/pm_messages.h"


//-----------------------------------------------------------------//
//Defines
//-----------------------------------------------------------------//

//-----------------------------------------------------------------//
//Macros
//-----------------------------------------------------------------//


   #ifdef __LOAD_LIBS_CPP
      VOID LoadExternalLibrary( CHAR *wLibraryName, VOID **wLibHandle );
      INT UnloadExternalLibrary( VOID *wLibHandle );
      VOID LoadIOSFunctions( VOID *wLibHandle );
      VOID LoadRTUControlFunctions( VOID *wLibHandle);
      VOID LoadRTUControlSelectFunctions( VOID *wLibHandle);
      INT (*FncRTUControl_Initialize)( VOID *);
      INT (*FncRTUControl_Start)( VOID);
      INT (*FncRTUControl_Finalize)( VOID);
      INT (*Fncusecsleep)(INT,INT);

      INT (*FncIO_Initialize)( VOID );
      INT (*FncIO_Start)( VOID);
      INT (*FncIO_Finalize)( VOID);
      INT (*FncIO_IsActive)( INT *);
      INT (*fncDIGIO_Enable_RS485)( VOID );
      INT (*FncDIGIO_SetRx_RS485)( VOID );
      INT (*FncDIGIO_SetTx_RS485)( VOID );
   #else
      extern VOID LoadExternalLibrary( CHAR *wLibraryName, VOID **wLibHandle );
      extern INT UnloadExternalLibrary( VOID *wLibHandle );
      extern VOID LoadIOSFunctions( VOID *wLibHandle );
      extern VOID LoadRTUControlFunctions( VOID *wLibHandle);
      extern VOID LoadRTUControlSelectFunctions( VOID *wLibHandle); 
      extern INT (*FncRTUControl_Initialize)( VOID *);
      extern INT (*FncRTUControl_Start)( VOID);
      extern INT (*FncRTUControl_Finalize)( VOID);
      extern INT (*Fncusecsleep)(INT,INT);

      extern INT (*FncIO_Initialize)( VOID );
      extern INT (*FncIO_Start)( VOID);
      extern INT (*FncIO_Finalize)( VOID);
      extern INT (*FncIO_IsActive)( INT *);
      extern INT (*fncDIGIO_Enable_RS485)( VOID );
      extern INT (*FncDIGIO_SetRx_RS485)( VOID );
      extern INT (*FncDIGIO_SetTx_RS485)( VOID );
   #endif

#endif




