function Decoder(bytes, port) {
  // Decode an uplink message from a buffer
  // (array) of bytes to an object of fields.
  var decoded = {};

  if (port === 2) // Port 2 is used by the GPS Beacons, the following code translates the payload received to the data of the application.
  {
    decoded.batterylevel=bytes[2];
    var a=bytes[1]>>6;
    if(a>0)
    {
      switch(a)
      {
        case 1:
          decoded.gpsfix="2D";
          break;
        case 2:
          decoded.gpsfix="3D";
          break;
        default :
          decoded.gpsfix="error";
          break;
      }
    }
    else
    {
      if(a==0)
      {
        decoded.gpsfix="No fixed position";
      }
      else
      {
        decoded.gpsfix="error";
      }
    }
    a=bytes[1]&63;
    switch(a)
    {
      case 2:
        decoded.reportType="Periodic mode report";
        break;
      case 4:
        decoded.reportType="Motion mode static report";
        break;
      case 5:
        decoded.reportType="Motion mode moving report";
        break;
      case 6:
        decoded.reportType="Motion mode static to moving report";
        break;
      case 7:
        decoded.reportType="Motion mode moving to static report";
        break;
      case 14:
        decoded.reportType="Help report";
        break;
      case 15:
        decoded.reportType="Low battery alarm report";
        break;
      case 17:
        decoded.reportType="Power on(temperature)";
        break;
      case 19:
        decoded.reportType="Power off(Low battery)";
        break;
      case 20:
        decoded.reportType="Power off(temperature)";
        break;
      default :
        decoded.reportType="undefined";
        break;
    }
    var test=bytes.slice(3,6);
    decoded.latitude=((bytes[3]<<24)+(bytes[4]<<16)+(bytes[5]<<8)+bytes[6])*0.000001;
    decoded.longitude=((bytes[7]<<24)+(bytes[8]<<16)+(bytes[9]<<8)+bytes[10])*0.000001;
    decoded.sensorType="GPS Beacon";
    
    
    
  }
  
  if(port==3)//port 3 is used by the Co2 and CO sensors
  {
    decoded.temperature=((bytes[1]<<8)+bytes[2])*0.01;
    decoded.humidity=((bytes[3]<<8)+bytes[4])*0.01;
    
    if(bytes[0]==2)// checks the type of device
    {
      decoded.COlevel=((bytes[5]<<8)+bytes[6])*0.01;
      decoded.sensorType="CO Sensor";
    }
    if(bytes[0]==1)
    {
      decoded.CO2level=((bytes[5]<<8)+bytes[6]);
      decoded.sensorType="CO2 Sensor";
    }
    
  }

  return decoded;
}
